/*
 * Created on 22.09.2004
 */
package bank;

/**
 * @author oliver
 * @since 22.09.2004
 */
public class Konto {

    private double kontostand = 0.0;

    public double abfragen() {
        return kontostand;
    }

    public void einzahlen(double betrag) {
        System.out.println(betrag + " soll eingezahlt werden");
        betragCheck(betrag);
        kontostand = kontostand + betrag;
        System.out.println(betrag + " auf Konto eingezahlt.");
    }

    public void abheben(double betrag) {
        System.out.println(betrag + " soll ausgezahlt werden");
        betragCheck(betrag);
        if (kontostand < betrag) {
            System.err.println("Konto nicht gedeckt, Auszahlung verweigert");
            throw new RuntimeException("keine Deckung");
        }
        kontostand = kontostand - betrag;
        System.out.println(betrag + " von Konto ausgezahlt.");
    }

    public void ueberweisen(double betrag, Konto anderesKonto) {
        System.out.println(betrag + " soll ueberwiesen werden");
        this.abheben(betrag);
        anderesKonto.einzahlen(betrag);
        System.out.println(betrag + " auf " + anderesKonto + " ueberwiesen");
    }

    private void betragCheck(double betrag) throws IllegalArgumentException {
        if (betrag < 0) {
            System.err.println("Aktion mit neg. Betrag verweigert");
            throw new IllegalArgumentException("Betrag negativ");
        }
    }

}
