/*
 * $Id: KontoAspect.aj,v 1.2 2005/09/19 09:51:38 boehm Exp $
 * (c)reated on 04.10.2004 by oliver
 */
package bank;

/**
 * @author oliver
 * @since 04.10.2004
 * @version $Revision: 1.2 $
 */
public aspect KontoAspect {
    
    pointcut callEinzahlen() :
        call(public void bank.Konto.einzahlen(double));

    pointcut executeEinzahlen() :
        execution(public void bank.Konto.einzahlen(double));
        
    pointcut callConstructor() :
        call(public bank.Konto.new());
        
    pointcut executeConstructor() :
        execution(public bank.Konto.new());
    
    pointcut getKontostand() :
        get(double bank.Konto.kontostand);
    
    pointcut setKontostand() :
        set(double bank.Konto.kontostand);

    pointcut handleArithmeticException() :
        handler(ArithmeticException);
    
    pointcut initializeKonto() :
        initialization(bank.Konto.new());

    pointcut preinitializeKonto() :
        preinitialization(bank.Konto.new());
    
    pointcut staticinitializeKonto() :
        staticinitialization(bank.Konto);

    before() : callEinzahlen() 
            || executeEinzahlen() 
            || callConstructor() 
            || executeConstructor()
            || getKontostand()
            || setKontostand() 
            || handleArithmeticException() 
            || initializeKonto() 
            || preinitializeKonto() 
            || staticinitializeKonto() {
        System.out.println(thisJoinPoint);
    }

}
