/*
 * Created on 30.04.2005
 *
 * $Id: AbzaehlAspekt.aj,v 1.1 2005/06/24 13:56:06 boehm Exp $
 */
package reim;

import java.util.*;

public aspect AbzaehlAspekt {
    
    before() : call(public String AbzaehlReim.abzaehlen(int, String...)) {
        System.out.println(">>> Abzaehl-Beginn <<<");
    }
    
    /**
     * Das geht nicht -- String... und String[] koennen nicht gemischt werden.
     */
//    after() : call(public String AbzaehlReim.abzaehlen(int, String[])) {
//        System.out.println(">>>  Abzaehl-Ende  <<<");
//    }
    
    before() : call(public AbzaehlReim.new(String...)) {
        System.out.println(">>> Initalisierung AbzaehlReim <<<");
    }
    
    /**
     * Unter 1.5.0M2 bekommt man hier einen adviceDidNotMathch
     * @see https://bugs.eclipse.org/bugs/show_bug.cgi?id=93356
     */
//    after() : call(public String AbzaehlReim.abzaehlen(int, ..)) {
//        System.out.println(">>>  Abzaehl-Ende  <<<");
//    }
    
    
    
    /////   Args und Varargs   /////

    /**
     * Vorgriff auf Kapitel 4 und args():
     * args(int, String...) und args(int, String[]) koennen hier beide
     * angewendet werden.
     */
    after() : call(public String AbzaehlReim.abzaehlen(int, String...))
            && args(int, String...) {
        System.out.println(">>>  Abzaehl-Ende  <<<");
    }
    
    /**
     * Hier in after(...) muss String[] verwendet werden, mit String... gibt
     * es eine Fehlermeldung ("The variable argument type String of the method
     * ajc$after$reim_AbzaehlAspekt$4$51babc49 must be the last parameter")
     * (AspectJ 1.5.0M2)
     */
    after(int i, String[] namen) : call(public String AbzaehlReim.abzaehlen(int, String...))
            && args(i, namen) {
        System.out.println(">>>  Ende von abzaehlen(" + i + ", "
                + Arrays.toString(namen) + ")  <<<");
    }
    
}
