package jrequest.base;



/**
 * A class to handle a change request and other kinds of requests
 *
 * created at Nov 8, 2002
 * @author daaby
 */

public class Request {

    /**
     * 
     * @uml.property name="state"
     * @uml.associationEnd multiplicity="(1 1)"
     */
    private State state = new State();

    /**
     * 
     * @uml.property name="description" multiplicity="(0 1)"
     */
    private String description = null;

    /**
     * 
     * @uml.property name="developer"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private User developer = null;

    /**
     * 
     * @uml.property name="description"
     */
    public void addDescription(String description) {
        if (this.description == null) {
            this.description = description;
        } else {
            this.description += description;
        }
    }

    /**
     * 
     * @uml.property name="description"
     */
    public String getDescription() {
        return description;
    }

        
    public void accept() {
        state.setAccepted();
    }

    public void assignTo(User user) {
        this.reassignTo(user);
//        state.setAssigned();
//        this.developer = user;
    }

    /**
     * 
     * @uml.property name="developer"
     */
    public void reassignTo(User user) {
        state.setAssigned();
        this.developer = user;
    }

    
    public void close() {
        state.setClosed();
    }
    
    public void reject() {
        state.setRejected();
    }

    public boolean isAccepted() {
        return state.isAccepted();
    }

    public boolean isAssigned() {
    	return state.isAssigned();
    }
    
    public boolean isClosed() {
    	return state.isClosed();
    }
    
    public boolean isRejected() {
        return state.isRejected();
    }

}
