/*
 * Created on Dec 18, 2003
 */
package toolbox;

import java.io.*;
import java.text.*;
import java.util.*;
import lotto.*;

/**
 * @author oliver
 */
public aspect LogAspect {
    
//    pointcut callAnyLottoMethod() : call(public * lotto..*(..));
//    
//    /**
//     * ermittelt Zeit- und Speicherverbrauch
//     */
//    before() : callAnyLottoMethod() {
//        System.out.println(thisJoinPoint);
//    }
    
//    pointcut callMixNumbers(int i) :
//        call(public void mixNumbers(int)) && args(i);
//    
//    before(int i) : callMixNumbers(i) {
//        Log.info(thisJoinPoint + " arg = " + i);
//    }
    
    pointcut callMixNumbers2(int min, int max) :
        call(public void mixNumbers(int, int)) && args(min, max);
    
//    before(int min, int max) : callMixNumbers2(min, max) {
//        Log.info("mixNumbers(..): min = " + min + ", max = " + max);
//        min = -1;       // hat keinerlei Auswirkung auf mixNumbers()
//    }
//
//    after(int min, int max) : callMixNumbers2(min, max) {
//        Log.info("after: min = " + min + ", max = " + max);
//    }
//
//    pointcut callMixNumbers3(int min, int max, Random random) :
//        call(public void mixNumbers(int, int, Random))
//            && args(min, max, random);
//    
//    before(int min, int max, Random random) :
//            callMixNumbers3(min, max, random) {
//        Log.info("mixNumbers(..): min = " + min + ", max = " + max
//                 + ", " + random);
//        Log.info(thisJoinPoint.getThis().toString());
//    }
//    
//    // nur 1. und letzten Parameter protokollieren
//    before(Object first, Object last) :
//            call(public void *(..))
//            && args(first, *, last) {
//        Log.info("ARGS = " + first + "..." + last + " for " + thisJoinPoint);
//    }
//    
//    // nur letzten Parameter protokollieren
//    before(Object last) :
//            call(public void *(..))
//            && args(*, last) {
//        Log.info("ARGS = ..." + last + " for " + thisJoinPoint);
//    }

//    pointcut callMixNumbers1or2(int min, int max) :
//        call(public void mixNumbers(int, int)) && args(min, max)
//        || call(public void mixNumbers(int)) && args(min);
//
//    pointcut setAttribute(Object newValue) :
//        set(* Trommel.*) && args(newValue);
//    
//    before(Object newValue) : setAttribute(newValue) {
//        Log.info(thisJoinPoint + " set to " + newValue);
//    }



//    before() : execution(public void main(..)) {
//        Log.init();
//    }



    pointcut executeZiehungStart(Ziehung z) : 
        execution(public void lotto.Ziehung.start())
        && this(z);
    
    after(Ziehung z) : executeZiehungStart(z) {
        Log.info("gezogene Zahlen: " + z);
    }
    
    
    
    pointcut executeGetWinners(String s) :
        execution(public List lotto.Ziehung.getWinners(String))
        && args(s);
    
    after(String s): executeGetWinners(s) {
        Log.info("Gewinner wurden aus <" + s + "> ermittelt.");
    }
    
    after(String s) returning: executeGetWinners(s) {
        Log.info("Gewinner wurden aus <" + s + "> erfolgreich ermittelt.");
    }
    
    after(String s) returning(List l): executeGetWinners(s) {
        Log.info("Liste der Gewinner: ");
        for (Iterator i = l.iterator(); i.hasNext();) {
            Schein schein = (Schein) i.next();
            Log.info("xxxxxx  " + schein.getSpieler());
        }
    }
    
    after() returning(Object o) :
            execution(public * lotto.Ziehung.*(..)) {
        Log.info(thisJoinPoint +  " returns " + o);
    }
    
    after(String s) throwing (IOException e): executeGetWinners(s) {
        Log.error("Fehler in " + thisJoinPoint, e);
        Log.error(s + " konnte nicht gelesen werden!");
    }
    
    
    
    /*
     * Log.info-Calls um weitere Infos erweitern...
     */
    
    public pointcut callLogInfo(String msg) :
        call(public void Log.info(String)) &&
        args(msg);
    
    void around(String msg) : callLogInfo(msg) {
        String extended = thisJoinPointStaticPart.getSourceLocation()
            + ": " + msg;
        proceed(extended);
    }
    
    
    
//    /*
//     * ein bisschen Werbung kann doch nicht schaden, oder?
//     */
//    
//    public pointcut callSystemOutPrintln(String msg) :
//        call(public void java.io.PrintStream.println(*)) &&
//        args(msg);
//    
//    void around(String msg) : callSystemOutPrintln(msg) {
//        if (new Random().nextInt(10) == 0) {
//            proceed ("*** " + msg + " ***\n"
//                + "Diese Ausgabe wurde ihnen pr?sentiert von: XXXXXX AG");
//        } else {
//            proceed(msg);
//        }
//    }

}
