/*
 * Created on Feb 23, 2004
 */
package lotto;

import java.io.*;

/**
 * @author oliver (boehm@javatux.de)
 */
public class Schein {
    
    private String spieler;     // Name des Spielers
    private int[] tip = new int[6];
    private int zusatzzahl;
    
    public String getSpieler() {
        return spieler;
    }
    
    public void setTip(int x1, int x2, int x3, int x4, int x5, int x6) {
        tip[0] = x1;
        tip[1] = x2;
        tip[2] = x3;
        tip[3] = x4;
        tip[4] = x5;
        tip[5] = x6;
    }
    
    public int[] getTip() {
        return tip;
    }
    
    public int getZusatzzahl() {
        return zusatzzahl;
    }
    
    public void read(Reader reader) throws IOException {
        StreamTokenizer tokenizer = new StreamTokenizer(reader);
        spieler = readNextString(tokenizer);
        for (int i = 0; i < 6; i++) {
            tip[i] = readNextInt(tokenizer);
        }
        zusatzzahl = readNextInt(tokenizer);
    }
    
    private String readNextString(StreamTokenizer tokenizer) 
            throws IOException {
        tokenizer.nextToken();
        if (tokenizer.ttype == StreamTokenizer.TT_EOF) {
            throw new EOFException("no more strings");
        }
        return tokenizer.sval;
    }
    
    private int readNextInt(StreamTokenizer tokenizer) throws IOException {
        tokenizer.nextToken();
        if (tokenizer.ttype == StreamTokenizer.TT_EOF) {
            throw new EOFException("no more numbers");
        }
        return (int) tokenizer.nval;
    }
    
    /**
     * Get Number of Richtige -- wieviel richtige wurden getippt?
     * @param gezogen
     * @return
     */
    public int getNoRichtige(int[] gezogen) {
        int richtige = 0;
        for (int i = 0; i < 6; i++) {
            if (isTipped(gezogen[i])) {
                richtige++;
            }
        }
        return richtige;
    }

    private boolean isTipped(int x) {
        for (int i = 0; i < 6; i++) {
            if (tip[i] == x) {
                return true;
            }
        }
        return false;
    }
    
    public String toString() {
        return ("" + tip[0] + " " + tip[1] + " " + tip[2]+ " " + tip[3] + " "
            + tip[4] + " " + tip[5] + " ZZ:" + zusatzzahl);
    }

    public static void main(String[] args)
            throws FileNotFoundException, IOException {
        Ziehung ziehung = new Ziehung();
        for (int i = 0; i < 1000; i++) {
            ziehung.start();
            System.out.println("Al-Capone\t" + ziehung.toShortString());
        }
    }

}
