/*
 * $Id: ZiehungAspect.aj,v 1.1 2005/06/24 13:56:07 boehm Exp $
 * (c)reated on 14.10.2004 by oliver
 */
package lotto;

import java.io.*;
import java.util.*;

/**
 * @author oliver
 * @since 14.10.2004
 * @version $Revision: 1.1 $
 */
public aspect ZiehungAspect {

    pointcut executeZieheZahl(Trommel t) :
        execution(private int Ziehung.zieheZahl(Trommel))&& args(t);

    before(Trommel t) : executeZieheZahl(t) {
        t.mixNumbers();
    }
    
    /////   Pre- und Postconditions   /////
    
    pointcut executeZiehungStart(Trommel t) :
        execution(public void Ziehung.start(Trommel)) && args(t);

    /**
     * Precondition fuer den Start der Ziehung
     */
//    before(Trommel t) : executeZiehungStart(t) {
//        if (t.getAnzahlKugelnInside() != 49) {
//            throw new IllegalArgumentException("keine 49 Kugeln in Trommel");
//        }
//    }
    before(Trommel t) : executeZiehungStart(t) {
        assert(t.getAnzahlKugelnInside() == 49);
    }
    
    /**
     * Postcondition
     */
    after(Trommel t) : executeZiehungStart(t) {
        assert(t.getAnzahlKugelnInside() == 43);
    }
    
    /////   return   /////
    
    before(Trommel t) : executeZieheZahl(t) {
        if (t.isMixed()) {
            return;     // Mischen nicht nötig
        }
        System.out.println("Mix it, Baby...");
        t.mixNumbers();
    }
    
    /////   unqualifizierter Advice   /////
    
    pointcut executeGetWinners2(Reader r) :
        execution(public List Ziehung.getWinners(Reader)
            throws IOException)
        && args(r);

    after(Reader r) : executeGetWinners2(r) {
        try {
            r.close();
        } catch (IOException ignored) {}
    }
    
}
