/*
 * Created on 13-Apr-04
 */
package lotto;

import java.io.*;
import org.apache.log4j.*;

/**
 * What do you want to log today?
 * 
 * @author oliver
 */
public privileged aspect LogAspect {
    
    private static Logger lotto.Ziehung.logger =
        Logger.getLogger(lotto.Ziehung.class);
    
    private static Logger lotto.Trommel.logger =
        Logger.getLogger(lotto.Trommel.class);
    
    private Logger logger = Logger.getLogger(LogAspect.class);
    
    static {
        //init("Lotto.log");
    }

    /**
     * sets up Log4J
     * @param filename  where to log the messages
     */
    public static void init(String filename) {
        try {
            Appender appender =
                new FileAppender(new PatternLayout("%3r %-5p %c - %m\n"),
                    filename, false);
            Logger.getRootLogger().addAppender(appender);
            System.out.println("Protokollierung: " + filename);
        } catch (IOException e) {
            BasicConfigurator.configure();
        }
    }
    
    before() : execution(public * lotto.Ziehung.*(..)) {
        lotto.Ziehung.logger.info(thisJoinPoint);
    }
    
    before() : execution(public * lotto.Trommel.*(..)) {
        lotto.Trommel.logger.info(thisJoinPoint);
    }

    after() returning(int z) :
            execution(private int lotto.Ziehung.zieheZahl()) {
        lotto.Ziehung.logger.info("gezogene Zahl: " + z);
    }
    
    after(Ziehung z) :
            execution(public void lotto.Ziehung.start())
            && this(z) {
        lotto.Ziehung.logger.info("gezogene Zahlen: " + z.zahl[0]
            + " " + z.zahl[1] + " " + z.zahl[2] + " ...");
    }

}
