/*
 * Created on Feb 24, 2004
 */
package lotto;

import java.io.*;
import java.util.*;

/**
 * @author oliver (boehm@javatux.de)
 */
public class Ziehung {

    private volatile String ident = "$Id: Ziehung.java,v 1.1 2005/06/24 13:56:06 boehm Exp $";
    private int[] zahl = new int[7];
    protected Trommel trommel = null;

    public int[] getZahlen() {
        return zahl;
    }

    /**
     * Die Ziehung der Lottozahlen beginnt...
     */
    public void start() {
        trommel = new Trommel();
        for (int i = 0; i < 6; i++) {
            zahl[i] = zieheZahl();
        }
        this.sort();
    }
    
    private int zieheZahl() {
        trommel.mixNumbers();
        return trommel.getNumber().intValue();
    }
    
    /**
     * Sortiert die Zahlen mittels Bubblesort.
     */
    private void sort() {
        boolean sorted = false;
        while (!sorted) {
            sorted = true;
            for (int i = 0; i < 5; i++) {
                if (zahl[i] > zahl[i+1]) {
                    sorted = false;
                    int tmp = zahl[i];
                    zahl[i] = zahl[i+1];
                    zahl[i+1] = tmp;
                }
            }
        }
    }
    
    public List getWinners() throws FileNotFoundException, IOException {
        return getWinners("Lotto.schein");
    }
    
    public List getWinners(String filename) 
            throws FileNotFoundException, IOException {
        List winners;
        Reader reader = new FileReader(filename);
        winners = getWinners(reader);
        reader.close();
        return winners;
    }

    public List getWinners(Reader reader) throws IOException {
        List winners = new Vector();
        try {
            while (reader.ready()) {
                Schein schein = new Schein();
                schein.read(reader);
                if (schein.getNoRichtige(zahl) >= 3) {
                    winners.add(schein);
                }
            }
        } catch (EOFException expected) {}
        return winners;
    }
    
    public String toString() {
        return "" + zahl[0] + " " + zahl[1] + " " + zahl[2] + " "
            + zahl[3] + " " + zahl[4] + " " + zahl[5];
    }
    
    public void printAbout() {
        System.out.println("Diese Ziehung wurde Ihnen prsentiert von: ");
        System.out.println("\tclass: " + this.getClass());
        System.out.println("\tident: " + ident);
    }
    
    public static void main(String[] args)
            throws FileNotFoundException, IOException {
        Ziehung ziehung = new Ziehung();
        ziehung.start();
        System.out.println("Ziehung: " + ziehung);
        List winners = ziehung.getWinners();
        for (Iterator i = winners.iterator(); i.hasNext();) {
            Schein schein = (Schein) i.next();
            System.out.println(schein.getSpieler() + "\t: "
                + schein.getNoRichtige(ziehung.getZahlen()) + " Richtige ("
                + schein + ")"); 
        }
        ziehung.printAbout();
    }

}
