/*
 * Created on Apr 15, 2004
 */
package bank;

import java.io.*;

/**
 * PersistenceAspect
 * realizes persistence using Castor framework.
 * 
 * @author oliver
 * @since  Apr 15, 2004
 */
public aspect PersistenceAspect {
    
    public void Persistence.store() throws IOException {
        FileOutputStream fstream  = new FileOutputStream(getFilename());
        ObjectOutputStream oostream = new ObjectOutputStream(fstream);
        oostream.writeObject(this);
        fstream.close();
    }
    
    public Persistence Persistence.load() throws IOException {
        FileInputStream fstream = new FileInputStream(getFilename());
        ObjectInputStream oostream = new ObjectInputStream(fstream);
        try {
            return (Persistence) oostream.readObject();
        } catch (ClassNotFoundException e) {
            throw new IOException(e.getMessage());
        }
        finally {
            fstream.close();
        }
    }

    private File Persistence.getFilename() {
        return new File("Konto", this.getId());
    }
    
    public void Persistence.delete() {
        this.getFilename().delete();
    }

}
