/*
 * Created on Dec 7, 2003
 */
package bank.test;

import java.io.*;

import bank.Konto;

import junit.framework.TestCase;

/**
 * @author oliver
 */
public class PersistenceTest extends TestCase {

    private Konto konto;

	/**
	 * Constructor for KontoTest.
	 * @param arg0
	 */
	public PersistenceTest(String arg0) {
		super(arg0);
	}

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        konto = new Konto(815, "Max Mustermann");
        super.setUp();
    }
    
    protected void tearDown() throws Exception {
        konto.delete();
    }

    public void testStoreAndLoad() throws IOException {
        Konto konto = new Konto(271828183, "H. Euler");
        konto.einzahlen(3.14);
        konto.store();
        Konto stored = (Konto) new Konto(271828183).load();
        assertEquals(konto, stored);
    }

    public void testPersistence() throws IOException {
        konto.setInhaber("Inge Inkongnito");
        konto.einzahlen(12.34);
        konto.store();
        Konto stored = (Konto) konto.load();
        assertEquals(konto, stored);
    }

    public void testLoadNotExistingKonto() throws IOException {
        try {
            assertNull(new Konto(-1).load());
        } catch (FileNotFoundException expected) {}
    }
    
    public void testDelete() throws IOException {
        Konto konto = new Konto(007, "James Bond");
        konto.store();
        konto.delete();
        try {
            assertNull(konto.load());
        } catch (FileNotFoundException expected) {}
    }
    
    public static void main(String args[]) {
        junit.swingui.TestRunner.run(PersistenceTest.class);
    }

}
