/*
 * Created on Jun 24, 2004
 */
package shell;
import java.io.*;

import org.aspectj.lang.SoftException;

/**
 * @author oliver
 */
public class History {
    
    private Writer out;
    private int n = 0;
    
    public History() {
        out = new StringWriter();
    }
    
    /**
     * Dieser Konstruktor ist nur zum Testen vorgesehen um zu sehen,
     * was passiert, wenn in add() doch eine IOException auftritt.
     * @param historyFile
     */
    public History(File historyFile) {
//        out = new FileWriter(historyFile);
        try {
            out = new FileWriter(historyFile);
//        } catch (IOException e) {
//            System.err.println("ERROR: " + e.getMessage());
//            System.err.println("Fallback: Ablage in StringWriter");
//            out = new StringWriter();
        } catch (SoftException e) {
            System.err.println("ERROR: " + e);
            System.err.println("Cause: " + e.getCause());
            e.getCause().printStackTrace();
            System.err.println("Fallback: Ablage in StringWriter");
            out = new StringWriter();
        }
    }

    public void add(String msg) {
        n++;
        out.write("" + n + "\t" + msg + "\n");
//        try {
//            out.write("" + n + "\t" + msg + "\n");
//        } catch (IOException canthappen) {}
    }
    
    /**
     * Diese Methode loescht die History.
     * @throws UnsupportedOperationException, da Implementierung noch fehlt
     */
    public void clear() {
        throw new UnsupportedOperationException("lazy developer");
    }
    
    public void show() {
        System.out.print(out.toString());
    }

}
