package de.aosd;

import java.io.*;

/**
 * Dieses Beispiel stammt direkt aus dem Developers Notebook, um die Generics
 * mit M4 auszuprobieren.
 * 
 * @author oliver
 * @since 22.10.2005
 */
public aspect IOExceptionHandling extends ExceptionHandling<IOException> {

    protected pointcut inExceptionHandlingScope() :
        call(* doIO*(..)) && within(de.aosd..*);
    
    /**
     * called whenever an IOException is thrown in scope.
     */
    protected void onException(IOException ex) {
        System.err.println("handled exception: " + ex.getMessage());
        //throw new IOException("kein Bock");
    }

}
