/*
 * Created on 02.05.2005
 *
 * $Id: FirmaTest.java,v 1.1 2005/06/24 13:56:05 boehm Exp $
 */
package verwaltung.test;

import junit.framework.TestCase;
import org.apache.log4j.*;
import verwaltung.*;
import verwaltung.log.*;

public class FirmaTest extends TestCase {
    
    private Firma firma = null;

    public static void main(String[] args) {
        junit.textui.TestRunner.run(FirmaTest.class);
    }

    protected void setUp() throws Exception {
        firma = new Firma("Rent-A-Visa GmbH", new Person("J.F."));
    }
    
    public void testFirma() {
        assertNotNull(firma);
        assertEquals(1, firma.getAnzahlMitarbeiter());
    }

    public void testEinstellen() {
        firma.einstellen(new Person());
        firma.einstellen(new Person("V."));
        assertEquals(3, firma.getAnzahlMitarbeiter());
    }

    public void testEntlassen() {
        testEinstellen();
        firma.entlassen(new Person());
        assertEquals(2, firma.getAnzahlMitarbeiter());
    }
    
    /**
     * Hier wird der Zugriff auf den Logger der verschiedenen
     * LogAspekt-Instanzen getestet.
     */
    public void testLogger() {
        Logger log = LogAspekt.aspectOf(Firma.class).log;
        log.info("Achtung, hier kommt der Firma-Logger!!!");
        assertNotNull(log);
    }

}
