/*
 * Created on 22.09.2004
 */
package bank;

import java.lang.annotation.Annotation;
import java.lang.reflect.Method;

import junit.framework.TestCase;

/**
 * @author oliver
 * @since 22.09.2004
 */
public class KontoTest extends TestCase {

    /**
     * 
     * @uml.property name="konto"
     * @uml.associationEnd 
     * @uml.property name="konto" multiplicity="(0 1)"
     */
    protected Konto konto;

    public static void main(String[] args) {
        junit.textui.TestRunner.run(KontoTest.class);
    }

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        konto = new Konto();
    }

    public void testAbfragen() {
        assertEquals(0.0, konto.abfragen(), 0.005);
    }

    public void testEinzahlen() {
        konto.einzahlen(1.23);
        assertEquals(1.23, konto.abfragen(), 0.005);
    }
    
    public void testAuszahlen() {
        //konto.auszahlen(1.11);
        konto.auszahlen(2);
    }

    public void testAbheben() {
        konto.einzahlen(4.50);
        konto.abheben(3.45);
        assertEquals(1.05, konto.abfragen(), 0.005);
    }

    public final void testUeberweisen() {
        Konto schwarzgeldKonto = new Konto();
        konto.einzahlen(5000.00);
        konto.ueberweisen(1000.00, schwarzgeldKonto);
        assertEquals(4000.00, konto.abfragen(), 0.005);
        assertEquals(1000.00, schwarzgeldKonto.abfragen(), 0.005);
    }
    
    public void testCopyrightAnnotation() {
        Class<Konto> cl = Konto.class;
        Annotation a = cl.getAnnotation(Copyright.class);
        System.out.println("Annotation = " + a);
    }
    
    public void testDeprecatedAnnotation() throws SecurityException,
            NoSuchMethodException {
        Method m = Konto.class.getMethod("auszahlen", Integer.class);
        Annotation a = m.getAnnotation(Deprecated.class);
        if (a != null) {
            System.out.println("method " + m + " is deprecated");
        }
//        System.out.println("Annotation von " + m + " = " + a);
//        Deprecated d = (Deprecated) a;
//        System.out.println("method " + m + " is deprecated");
    }

}
