/*
 * Created on 23.02.2005
 *
 * $Id: Cashflow.aj,v 1.1 2005/06/24 13:56:05 boehm Exp $
 */
package vorfahr;


/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 23.02.2005
 * @version $revision$
 */
public aspect Cashflow {

    /**
     * Pointcut mit Annotation
     */
    pointcut hatGeldCall() :
        call(@HatGeld * Grossvater.anpumpen(int));

    before(Grossvater x) : hatGeldCall() && target(x) {
        //System.out.println("-> @HatGeld: " + thisJoinPoint);
        System.out.println("\t" + x + " hat Geld -> anpumpen");
    }
 
    /**
     * Pointcut ohne Annotation
     */
    pointcut anpumpenCall() :
        call(* Grossvater.anpumpen(int));
    
    before(Grossvater x) : anpumpenCall() && target(x) {
        System.out.println("\t" + x + " wird angepumpt");
    }
    
    /**
     * Annotation der Grossvater-Linie ueberpruefen;
     * Falls "Vater" ebenfalls die @Vorfahr-Annotation hat, sollte in der
     * Ausgabe "-> call(vorfahr.Vater())" auftauchen.
     */
    pointcut initVorfahr() :
        call((@Vorfahr *).new());
    
    before() : initVorfahr() {
        System.out.println("-> " + thisJoinPoint);
    }

}
