/*
 * Created on 14.02.2005
 *
 * $Id: FareCalculatorTest.java,v 1.1 2005/06/24 13:56:07 boehm Exp $
 */
package space.test;

import java.util.Date;

import junit.framework.TestCase;
import space.FareCalculator;

/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 14.02.2005
 * @version $revision$
 */
public class FareCalculatorTest extends TestCase {
    
    private FareCalculator fareCalculator;

    public static void main(String[] args) {
        junit.textui.TestRunner.run(FareCalculatorTest.class);
    }

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        fareCalculator = FareCalculator.getInstance();
        assertNotNull(fareCalculator);
    }

    /**
     * If you uncomment the constructor call you should get an error message
     * like "please use getInstance()"
     */
    public void testConstructor() {
        //fareCalculator = new FareCalculator();
    }

    /**
     * Class under test for double getFare(Date, Date, long)
     */
    public void testGetFareDateDatelong() {
        long t0 = System.currentTimeMillis();
        long t1 = t0 + 60000;
        Date d0 = new Date(t0);
        Date d1 = new Date(t1);
        double fare = fareCalculator.getFare(d0, d0, 0);
        assertEquals(2.0, fare, 0.005);
        fare = fareCalculator.getFare(d0, d1, 1000);
        assertEquals(202.5, fare, 0.005);
    }

    /**
     * Class under test for double getFare(long, long)
     */
    public void testGetFarelonglong() {
        double fare = fareCalculator.getFare(0, 0);
        assertEquals(2.0, fare, 0.005);
        fare = fareCalculator.getFare(10, 1000);
        assertEquals(207.0, fare, 0.005);
    }

}
