/*
 * Created on Jun 7, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package emma.laden.test;

import java.lang.annotation.Annotation;
import java.lang.reflect.Method;

import junit.framework.TestCase;
import emma.laden.*;
import emma.laden.annotation.*;
import emma.laden.werbung.*;

/**
 * RechnungTest
 * 
 * @author oliver
 * @since  Jun 7, 2004
 */
public class RechnungTest extends TestCase {
    
    private Rechnung rechnung;

    /**
     * Constructor for RechnungTest.
     * @param arg0
     */
    public RechnungTest(String arg0) {
        super(arg0);
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(RechnungTest.class);
    }

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        rechnung = new Rechnung();
        rechnung.addArtikel(new Artikel("Kaffee", 8.50));
        rechnung.addArtikel(new Artikel("Tiefkuehlpizza", 6.50));
    }
    
    public void testGetSumme() {
        assertEquals(15.00, rechnung.getSumme(), 0.001);
    }
    
    public void testEndpreis() {
        double endpreis = rechnung.getEndpreis();
        System.out.println("Endpreis = " + endpreis);
        assertTrue(endpreis <= 15.00);
        assertTrue(endpreis > 0.0);
    }
    
    public void testPrint() {
        System.out.println();
        rechnung.print();
        System.out.println();
    }
    
    public void testAnnotatedClass() {
        checkAnnotation(Rechnung.class, Copyright.class);
    }
    
    public void testAnnotatedAspect() {
        checkAnnotation(BierWerbung.class, PremiumPartner.class);
    }

    private void checkAnnotation(Class<? extends Object> cl, Class annotation) {
        Annotation a = cl.getAnnotation(annotation);
        //System.out.println("Annotation = " + a);
        assertNotNull(a);
    }
    
    public void testMethodAnnoation() throws SecurityException,
            NoSuchMethodException {
        Method m = Rechnung.class.getMethod("getEndpreis", (Class[]) null);
        Annotation a = m.getAnnotation(Logged.class);
        assertNotNull(a);
    }

}
