package verwaltung.test;

import org.aspectj.lang.*;
import org.aspectj.lang.annotation.*;

@Aspect
public class TestAspekt {

	/*
	 * if()-Pointcut
	 */
	
    @Pointcut("call(void *..set*(*)) && args(arg) && if()")
    public static boolean nullCall(Object arg) {
    	return arg == null;
    }
    
    @Before("nullCall(arg)")
    public void beforeAdviceForNullCall(Object arg) {
    	System.err.println("Ups, eine Methode mit arg = " + arg
    			+ " wurde aufgerufen!");
    }
    
    
    
    /*
     * if()-Pointcut mit Zugriff auf Joinpoint
     */

    @Pointcut("call(void *..set*(*)) && args(arg) && if()")
    public static boolean nullTestCall(Object arg, JoinPoint jp,
            JoinPoint.EnclosingStaticPart esjp) {
        return arg == null
                && jp.getSignature().getDeclaringTypeName().endsWith("Person")
                && esjp.getSignature().getName().startsWith("test");
    }

    @Before("nullTestCall(arg, jp, esjp)")
    public void beforeAdviceForNullCall(Object arg, JoinPoint jp,
            JoinPoint.EnclosingStaticPart esjp) {
        System.err.println(jp.toShortString() + " wurde mit (null) von "
                + esjp.toShortString() + " aufgerufen!");
    }

}
