/*
 * Created on Dec 8, 2003
 */
package toolbox;

/**
 * @author oliver
 */
public aspect ProfilerAspect {
    
    pointcut executeAnyPublicMethod() : execution(public * lotto..*(..))
        && !execution(public * toolbox..*(..));
    
    /**
     * ermittelt Zeit- und Speicherverbrauch
     */
    Object around() : executeAnyPublicMethod() {
        long t = System.currentTimeMillis();
        long mem = Runtime.getRuntime().freeMemory();
        try {
            return proceed();
        } finally {
            t = System.currentTimeMillis() - t;
            if (t >= 1) {              // filter out the short living methods
                mem = mem - Runtime.getRuntime().freeMemory();
                ProfilerLog.profile("time: " + t + " ms, memory = " + mem
                    + " bytes for " + thisJoinPoint);
            }
        }
    }

//    /**
//     * ermittelt Zeitverhalten
//     */
//    Object around() : execution(public * lotto..*(..)) {
//        long t = System.currentTimeMillis();
//        Object toreturn = proceed();
//        t = System.currentTimeMillis() - t;
//        Log.profile(thisJoinPoint + ": t = " + t
//            + " ms, return = " + toreturn);
//        return toreturn;
//    }
//    void around() : execution(public void lotto..*(..)) {
//        long t = System.currentTimeMillis();
//        proceed();
//        t = System.currentTimeMillis() - t;
//        ProfilerLog.profile(thisJoinPoint + ": t = " + t + " ms");
//    }

//    /**
//     * ermittelt Zeitverhalten
//     */
//    Object around() : execution(public * lotto..*(..)) {
//        long t = System.currentTimeMillis();
//        try {
//            return proceed();
//        } finally {
//            t = System.currentTimeMillis() - t;
//            Log.profile("time: " + t + " ms for " + thisJoinPoint);
//        }
//    }
    
    /**
     * Zuerst noch schnell das Logging-Framework initialisieren...
     */
    before() : execution(public static void *..main(String[])) {
        ProfilerLog.init();
    }

}
