/*
 * Created on 06.04.2005
 *
 * $Id: SubjectAspect.aj,v 1.1 2005/06/24 13:56:05 boehm Exp $
 */
package pattern.observer;

import java.util.*;

/**
 * It seems that AspectJ 1.5M2 has some problems with generics.
 * I got an error message at "observers.add(observer)". The same code
 * in a Java class I got no compilation error.
 * 
 * @see https://bugs.eclipse.org/bugs/show_bug.cgi?id=91053
 */
public aspect SubjectAspect {
    
    private Set Subject.observers = new HashSet();

    public void Subject.addObserver(SubjectObserver observer) {
        observers.add(observer);
    }

    public void Subject.notifyObservers() {
        for (Iterator i = observers.iterator(); i.hasNext(); ) {
            SubjectObserver observer = (SubjectObserver) i.next();
            observer.update(this);
        }
    }
    
    
    
    /**
     * call notifyObservers() automatically each time an attribut changes
     */
    after(SmartSubject subject) : set(Object+ SmartSubject+.*)
            && this(subject) {
        subject.notifyObservers();
    }
    
}
