/*
 * Created on 16.11.2004
 *
 * $Id$
 */
package trouble.out;

import java.io.*;

/**
 * Einige Pointcuts, um System.out.println(..) zu addressieren.
 * Um nicht die Warnungen in sämtlichen Klassen zu erhalten, ist
 * die Auswirkung der declare-Anweisungen auf die Printer-Klasse
 * beschränkt (within(Printer)).
 * 
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 16.11.2004
 * @version $revision$
 */
public aspect PrinterAspect {

    declare warning : call(public void System.out.println(..)) :
        "tote Deklaration";
    
    declare warning : call(public void PrintStream.println(..))
            && within(Printer):
        "don't use PrintStream.println(..)";
    
    declare warning : get(public PrintStream System.out)
            && within(Printer):
        "don't use System.out";

    /**
     * so geht's leider nicht :-(
     */
    declare warning : get(public PrintStream System.out)
            && call(public void PrintStream.println(..))
            && within(Printer):
        "don't use System.out.println()";

}
