/*
 * Created on 24.08.2004
 */
package verwaltung;

import java.util.*;

import junit.framework.TestCase;

/**
 * @author oliver
 * @since 24.08.2004
 */
public class PersonTest extends TestCase {
    
    private Person hugo = null;

    public static void main(String[] args) {
        junit.textui.TestRunner.run(PersonTest.class);
    }

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        hugo = new Person("Hugo");
    }

    /*
     * Class under test for void Person(String)
     */
    public final void testValidEmail() {
        hugo.setEmail("hugo@n-irgend.wo");
    }
    
    public final void testInvalidEmail() {
        try {
            hugo.setEmail("abc");
            fail("Where is the IllegalArgumentException?");
        } catch (IllegalArgumentException expected) {}       
    }
    
    public final void testSetEmailWithoutSetter() {
        hugo.email = "hugo@wer.da";
        try {
            hugo.email = "invalid";
            fail("Where is the IllegalArgumentException?");
        } catch (IllegalArgumentException expected) {}       
    }
    
//    public final void testSetNameWithoutSetter() {
//        try {
//            hugo.name = "Hase";
//            fail("read-only attribut violated");
//        } catch (RuntimeException expected) {}
//    }

    public final void testVolljaehrigkeit() {
        Calendar geburt = new GregorianCalendar();
        geburt.add(Calendar.YEAR, -18);
        hugo.geburtstag = geburt.getTime();
        assertTrue(hugo.isVolljaehrig());
        geburt.add(Calendar.DAY_OF_YEAR, 1);
        hugo.geburtstag = geburt.getTime();
        assertFalse(hugo.isVolljaehrig());
    }
 
}
