/*
 * Created on 08.02.2005
 *
 * $Id$
 */
package abrechnung;

import java.io.IOException;

import junit.framework.TestCase;

/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 08.02.2005
 * @version $revision$
 */
public class KaffeeListeTest extends TestCase {

    public static void main(String[] args) {
        junit.textui.TestRunner.run(KaffeeListeTest.class);
    }
    
    private KaffeeListe liste;

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        liste = new KaffeeListe();
        liste.addTassen("Hugo", 5);
    }
    
    protected void tearDown() throws Exception {
        IoSimulator.reset();
    }

    public void testAddTasse() {
        liste.addTasse("Hugo");
        assertEquals(6, liste.getAnzahlTassen("Hugo"));
    }
    
    public void testAdd11Tassen() {
        liste.addTasse("Caesar");
        liste.addTassen("Caesar", 10);
        assertEquals(11, liste.getAnzahlTassen("Caesar"));
    }
    
    public void testZahleTassen() {
        liste.addTassen("Julius", 5);
        liste.zahleTassen("Julius", 4);
        assertEquals(1, liste.getAnzahlTassen("Julius"));
    }
    
    public void testZahleAlleTassen() {
        liste.zahleAlleTassen("Hugo");
        assertEquals(0, liste.getAnzahlTassen("Hugo"));
    }
    
    public void testEquals() {
        KaffeeListe l1 = new KaffeeListe();
        KaffeeListe l2 = new KaffeeListe();
        assertEquals(l1, l2);
        l1.addTasse("James");
        assertFalse(l1.equals(l2));
        l2.addTasse("James");
        assertEquals(l1, l2);
    }
    
    public void testClone() {
        KaffeeListe cloned = liste.clone();
        assertEquals(liste, cloned);
    }
    
    public void testStore() throws IOException {
        liste.store();
        KaffeeListe kopie = new KaffeeListe();
        kopie.load();
        assertEquals(liste, kopie);
    }
    
    public void testDiskFullAndStore() throws IOException {
        liste.store();
        KaffeeListe kopie = liste.clone();
        liste.addTasse("Agatha");
        try {
            IoSimulator.diskFull = true;
            liste.store();
            fail("IOException expected");
        } catch (IOException expected) {}
        liste.load();
        assertEquals(kopie, liste);
    }

}
