/*
 * Created on 31.08.2004
 */
package flirt;


/**
 * @author oliver
 * @since 31.08.2004
 */
public aspect PersonAspect {
            
    /**
     * Unterschiede zwischen "Call" und "Execution"
     */
    before(): call(void Person.loves(Person)) {
        System.out.println("before(): " + thisJoinPoint);
    }
    after() : call(void Person.loves(Person)) {
        System.out.println("after() : " + thisJoinPoint);
    }
    before(): execution(void Person.loves(Person)) {
        System.out.println("before(): " + thisJoinPoint);
    }
    after() : execution(void Person.loves(Person)) {
        System.out.println("after() : " + thisJoinPoint);
    }
    pointcut empty() :
        call(void Person.loves(Person)) && execution(void Person.loves(Person));
    

    
    
    /**
     * this() und target()
     */
    
    pointcut lovecall(Person p1, Person p2) :
        call(public void Person.loves(Person)) 
        && this(p1) && target(p2);
    
//    before(Person p1, Person p2) : lovecall(p1, p2) {
//        System.out.println("loves-call-before: this=" + p1
//                + ", target=" + p2);
//    }

    after(Person p1, Person p2) : lovecall(p1, p2) {
        System.out.println("loves-call     : this=" + p1
                + ", target=" + p2);
    }
    
    pointcut dolove(Person p1, Person p2) :
        execution(public void Person.loves(Person)) 
        && this(p1) && target(p2);
    
//    before(Person p1, Person p2) : dolove(p1, p2) {
//        System.out.println("loves-execution-before: this=" + p1
//            + ", target=" + p2);
//    }

    after(Person p1, Person p2) : dolove(p1, p2) {
        System.out.println("loves-execution: this=" + p1
            + ", target=" + p2);
    }

}

