/*
 * Created 20-Nov-04
 */
package toolbox;

/**
 * @author mailto:boehm@javatux.de
 */
public aspect ProfilerAspect {
    
    pointcut methodsToMeasure() : 
        (execution(public * *..*(..))
        || execution(public *..new(..)))
        && !within(*..*Test)
        && !within(ProfilerAspect);
    
    /**
     * ermittelt Zeit-verbrauch
     */
//    Object around() : methodsToMeasure() {
//        long t = System.currentTimeMillis();
//        try {
//            return proceed();
//        } finally {
//            t = System.currentTimeMillis() - t;
//            if (t >= 1) {     // filter out the short runners
//                System.out.println("time: " + t
//                    + " ms for " + thisJoinPoint);
//            }
//        }
//    }

    Object around() : methodsToMeasure() {
        long t = System.currentTimeMillis();
        long mem = Runtime.getRuntime().freeMemory();
        try {
            return proceed();
        } finally {
            t = System.currentTimeMillis() - t;
            if (t >= 1) {              // filter out the short living methods
                mem = mem - Runtime.getRuntime().freeMemory();
                System.out.println("time: " + t + " ms, memory = " + mem
                    + " bytes for " + thisJoinPoint);
            }
        }
    }

}
