/*
 * Created on 21.11.2004
 *
 * $Id: LogTable.java,v 1.1 2005/06/24 13:56:04 boehm Exp $
 */
package toolbox;

import java.io.*;

import org.aspectj.lang.JoinPoint;

/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 21.11.2004
 * @version $revision$
 */
public class LogTable {
    
    private Writer writer = null;
    
    public LogTable() {
        this("profile.csv");
    }
    
    public LogTable(String filename) {
        this.init(filename);
    }

    /**
     * Log-Datei anlegen und oeffnen
     */
    public void init(String filename) {
        if (writer == null) {
            try {
                writer = new BufferedWriter(new FileWriter(filename));
                System.out.println("Log-File: " + filename);
            } catch (IOException e) {
                writer = new PrintWriter(System.err);
            }
            writeHeader();
        }
    }
    
    protected void writeHeader() {
        writeln("Methode,Zeit (ms),Speicher (Bytes)");
    }
    
    public void add(JoinPoint point, long time, long mem) {
        writeln(point.getSignature().toShortString() + "," + time + "," + mem);
    }
    
    protected void writeln(String line) {
        try {
            writer.write(line + "\n");
            writer.flush();
        } catch (IOException e) {
            System.err.println(line);
        }
    }
    
    protected void finalize() {
        exit();
    }

    public void exit() {
        if (writer == null) {
            return;
        }
        try {
            writer.flush();
            writer.close();
            System.out.println("Log-File closed");
            writer = null;
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}
