/*
 * Created on 22.11.2004
 *
 * $Id$
 */
package toolbox;

import java.util.*;
import java.util.Hashtable;

import org.aspectj.lang.*;
import org.aspectj.lang.JoinPoint;

/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 22.11.2004
 * @version $revision$
 */
public class LogHashTable extends LogTable {
    
    private Hashtable table = new Hashtable();
    
    protected void writeHeader() {
        writeln("Methode,Zeit (ms),Speicher (Bytes),Anzahl");
    }

    public void add(JoinPoint point, long time, long mem) {
        add(point.getSignature(), new Measurement(time, mem));
    }
    
    public void add(Signature signature, Measurement measurement) {
        Measurement old = (Measurement) table.get(signature);
        if (old == null) {
            table.put(signature, measurement);
        } else {
            old.add(measurement);
        }
    }
    
    protected void finalize() {
        exit();
    }
    
    public void exit() {
        for (Enumeration i = table.keys(); i.hasMoreElements(); ) {
            Signature signature = (Signature) i.nextElement();
            Measurement measurement = (Measurement) table.get(signature);
            writeln(signature, measurement);
        }
        super.exit();
    }
    
    private void writeln(Signature signature, Measurement measurement) {
        writeln(signature.toShortString() + "," + measurement.toCSV());
    }

}
