/*
 * Created on 22.11.2004
 *
 * $Id$
 */
package toolbox;

/**
 * Diese Klasse nimmt die Messerte wie Zeit und Speicherverbrauch
 * auf.
 * 
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 22.11.2004
 * @version $revision$
 */
public class Measurement {

    private int n;      // number of calls
    private long time;
    private long mem;
    
    /**
     * Weil ein negativer Speicherverbrauch keinen Sinn macht (hier hat
     * offensichtlich der Garbage Collector zugeschlagen), wird dieser
     * Messwert ignoriert.
     * 
     * @author <a href="mailto:boehm@javatux.de">oliver</a>
     * @since 22.11.2004
     * @param time
     * @param mem
     */
    public Measurement(long time, long mem) {
        this.n = 1;
        this.time = time;
        if (mem > 0) {
            this.mem = mem;
        }
    }
    
    public void add(Measurement other) {
        this.n += other.n;
        this.time += other.time;
        this.mem += other.mem;
    }
    
    public String toCSV() {
        return ("" + time + "," + mem + "," + n);
    }
    
}
