/*
 * Created on 30.03.2005
 *
 * $Id: AccountTest.java,v 1.1 2005/06/24 13:56:05 boehm Exp $
 */
package web;

import java.util.Properties;

import web.Account;

import junit.framework.TestCase;

public class AccountTest extends TestCase {
    
    static public Properties props = null;
    public Account bond = new Account("Bond");

    public static void main(String[] args) {
        junit.textui.TestRunner.run(AccountTest.class);
    }

    protected void setUp() throws Exception {
        if (props == null) {
            props = new Properties();
            props.load(AccountTest.class.getResourceAsStream("/passwd.properties"));
        }
        assertFalse(props.isEmpty());
    }

    public void testIsValid() {
        String password = props.getProperty(bond.getName());
        assertTrue(bond.isValid(password));
    }
    
    public void testInvalidPassword() {
        assertFalse(bond.isValid("falsches Passwort"));
    }
    
    public void testInvalidUser() {
        Account dummy = new Account("dummy");
        assertNull(props.getProperty(dummy.getName()));
        assertFalse(dummy.isValid("dummy"));
    }
    
    public void testNullPassword() {
        assertFalse(bond.isValid(null));
    }

}
