/*
 * $Id: ShotTest.java,v 1.1 2005/06/24 13:56:04 boehm Exp $
 *
 * Copyright (c) 2001 Oliver Boehm (mailto:boehm@2xp.de)
 * http://www.2xp.de
 * All rights reserved.
 *
 * -----------------------------------------
 *
 * $Author: boehm $
 * $Date: 2005/06/24 13:56:04 $
 * $Revision: 1.1 $
 *
 * $Log: ShotTest.java,v $
 * Revision 1.1  2005/06/24 13:56:04  boehm
 * Einspielen der Beispiele und Uebungen inkl. HTML-Seiten
 *
 * Revision 1.3  2001/12/27 16:21:33  oliver
 * HumanPlayer and Player.main() added
 *
 * Revision 1.2  2001/12/23 20:39:35  oliver
 * Player.turn() implemented
 *
 * Revision 1.1  2001/12/22 20:02:19  oliver
 * ShotTest object added / Shot extended
 *
 */



package armada.test;



import junit.framework.*;
import armada.*;



public class ShotTest extends TestCase {

    public ShotTest(String name) {
        super(name);
    }

    public void testShot() throws ShotException {
    	Shot shot1 = new Shot("A0");
    	Shot shot2 = new Shot('a', 0);
    	Shot shot3 = new Shot(1, 1);
    	assertEquals(shot1, shot2);
    	assertEquals(shot1, shot3);
    	Shot shot4 = new Shot("h7");
    	Shot shot5 = new Shot('H', 7);
    	Shot shot6 = new Shot(8, 8);
    	assertEquals(shot4, shot5);
    	assertEquals(shot4, shot6);
    }

    public void testNeighbourShot() throws ShotException {
        Shot shot = new Shot();
        Shot oldShot = shot;
        Shot shotUp = shot.up();
        assertEquals(shotUp.down(), shot);
        Shot leftShot = shot.left();
        assertEquals(leftShot.right(), shot);
        assertEquals(oldShot, shot);
    }
    
    public void testHit() {
    	Shot shot = new Shot();
    	shot.setHit('1');
    	assertTrue(shot.isHit());
    	shot.setHit(Board.EMPTY);
    	assertTrue(!shot.isHit());
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(ShotTest.class);
    }
}

