/*
 * $Id: HumanPlayer.java,v 1.1 2005/06/24 13:56:04 boehm Exp $
 *
 * Copyright (c) 2001 Oliver Boehm (mailto:boehm@2xp.de)
 * http://www.2xp.de
 * All rights reserved.
 *
 * -----------------------------------------
 *
 * $Author: boehm $
 * $Date: 2005/06/24 13:56:04 $
 * $Revision: 1.1 $
 *
 * $Log: HumanPlayer.java,v $
 * Revision 1.1  2005/06/24 13:56:04  boehm
 * Einspielen der Beispiele und Uebungen inkl. HTML-Seiten
 *
 * Revision 1.1  2001/12/27 16:21:33  oliver
 * HumanPlayer and Player.main() added
 *
 */



package armada;



import java.io.*;



public class HumanPlayer extends Player {
    
    /** needed for Serializable */
    private static final long serialVersionUID = 3258410646956619569L;

    public HumanPlayer() {
        this(System.getProperty("user.name"));
    }
    
    public HumanPlayer(String name) {
        super(name);
    }

    /*
     * @see Player#turn()
     */
    public Shot turn() {
    	Shot shot = null;
    	
    	// read input
    	System.out.print("    " + name + ": ");
        BufferedReader reader = new BufferedReader(
                new InputStreamReader(System.in));
        try {
            String line = reader.readLine();
            shot = new Shot(line);
        } catch (ShotException se) {
            System.err.println("falsche Eingabe " + se);
            return turn();	     // try it again
        } catch (IOException ioe) {
            System.err.println("internal error\n" + ioe);
        } catch (Exception e) {
            System.err.println("bitte nochmal versuchen");
            return turn();
        }
        
        // mark hit
    	char hit = opponent.board.shootTo(shot);
    	if ((hit >= '1') && (hit <= '4')) {	// hit ship
    	    shot.setHit(hit);
    	}
    	return shot;
    }

}

